; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_TEST:
	ldi temp,2
	rcall LCD_PAGE_SET ; inp: temp (0..7)

	ldi temp,127
LCD_TEST_w:	
	ldi temp,0b10101010
	rcall LCD_DATA			 ; inp: temp
	dec temp1
	brne LCD_TEST_w
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_INITIALISIERUNG:

	cbi PORTB,LCD_RES	; RESET auf LOW		
	rcall wait_100ms
	sbi PORTB,LCD_RES	; RESET  auf HIGH	
	rcall wait_100ms
	
	ldi temp,0x40		; Start Line 0		
	rcall LCD_COMMAND 	

	ldi temp,0xA1		; ADC reverse		
	rcall LCD_COMMAND 

	ldi temp,0xC0		; Normal COM0-COM63	
	rcall LCD_COMMAND 

	ldi temp,0xA6		; Display normal	
	rcall LCD_COMMAND 

	ldi temp,0xA2		; SET BIAS			
	rcall LCD_COMMAND 

	ldi temp,0x2F		; BOOSTER			
	rcall LCD_COMMAND 

	ldi temp,0xF8		; Set Booster internal to 4x
	rcall LCD_COMMAND 

	ldi temp,0x00		; 
	rcall LCD_COMMAND 

	ldi temp,0x27		; CONTRAST			
	rcall LCD_COMMAND 

	ldi temp,0x81		; CONTRAST			
	rcall LCD_COMMAND 

	ldi temp,0x16		; CONTRAST			
	rcall LCD_COMMAND 

	ldi temp,0xAC		; No indicator		
	rcall LCD_COMMAND 

	ldi temp,0x00		; 
	rcall LCD_COMMAND 

	ldi temp,0xAF		; Display on		
	rcall LCD_COMMAND 


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; inp: temp																		
;																				
;	rcall LCD_COMMAND ; inp: temp												
;																				
LCD_DATA:
	sbi PORTB,LCD_A0			; A0 auf HIGH	

	cbi PORTB,LCD_CS			; CS auf LOW	

	nop							; kurze Pause (muss aber nicht unbedingt sein)
	nop
	nop

	rcall SPI_SENDEN_EINLESEN	; SPI INP: TEMP OUT: temp

	sbi PORTB,LCD_CS			; CS auf HIGH	

	nop							; kurze Pause (muss aber nicht unbedingt sein)
	nop
	nop

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; inp: temp																		
;																				
;	rcall LCD_COMMAND ; inp: temp												
;																				
LCD_COMMAND:

	cbi PORTB,LCD_A0			; A0 auf LOW	

	cbi PORTB,LCD_CS			; CS auf LOW	

	nop							; kurze Pause (muss aber nicht unbedingt sein)
	nop
	nop


	rcall SPI_SENDEN_EINLESEN	; SPI INP: TEMP OUT: temp

	sbi PORTB,LCD_CS			; CS auf HIGH	

	nop							; kurze Pause (muss aber nicht unbedingt sein)
	nop
	nop


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; inp: temp																		
;																				
;	rcall LCD_PAGE_SET ; inp: temp (0..7)										
;																				
LCD_PAGE_SET:
	push temp1

	andi temp,0b00000111
	ldi temp1,0b10110000

	add temp,temp1
	rcall LCD_COMMAND

	pop temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_CLEAR:
	ldi temp,0
	rcall LCD_PAGE_SET ; inp: temp (0..7)
	rcall LCD_CLEAR_SCHLEIFE

	ldi temp,1
	rcall LCD_PAGE_SET ; inp: temp (0..7)
	rcall LCD_CLEAR_SCHLEIFE

	ldi temp,2
	rcall LCD_PAGE_SET ; inp: temp (0..7)
	rcall LCD_CLEAR_SCHLEIFE

	ldi temp,3
	rcall LCD_PAGE_SET ; inp: temp (0..7)
	rcall LCD_CLEAR_SCHLEIFE

	ldi temp,4
	rcall LCD_PAGE_SET ; inp: temp (0..7)
	rcall LCD_CLEAR_SCHLEIFE

	ldi temp,5
	rcall LCD_PAGE_SET ; inp: temp (0..7)
	rcall LCD_CLEAR_SCHLEIFE

	ldi temp,6
	rcall LCD_PAGE_SET ; inp: temp (0..7)
	rcall LCD_CLEAR_SCHLEIFE

	ldi temp,7
	rcall LCD_PAGE_SET ; inp: temp (0..7)
	rcall LCD_CLEAR_SCHLEIFE


ret
;---------------
LCD_CLEAR_SCHLEIFE:
	ldi temp1,255
LCD_CLEAR_SCHLEIFE_w:	
	ldi temp,0b00000000
	rcall LCD_DATA
	dec temp1
	brne LCD_CLEAR_SCHLEIFE_w
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################